#!/usr/bin/env python
import rospy
from subprocess import * 
from std_msgs.msg import Int32
import time
import smbus
import esp_reset
i2c = smbus.SMBus(1)
addr = 0x27
key = 0x76
array = [0] * 3
row = [0] * 4
mode = 0

def kill_map():
	h=Popen('exec rosnode kill base_link_connect',shell=True,stdout=PIPE)
	h=Popen('exec rosnode kill calculater',shell=True,stdout=PIPE)
	h=Popen('exec rosnode kill cartographer_node',shell=True,stdout=PIPE)
	h=Popen('exec rosnode kill cartographer_occupancy_grid_node',shell=True,stdout=PIPE)
	h=Popen('exec rosnode kill move_base',shell=True,stdout=PIPE)
	h=Popen('exec rosnode kill robot_state_publisher',shell=True,stdout=PIPE)
	h=Popen('exec rosnode kill show_rviz',shell=True,stdout=PIPE)
	h=Popen('exec rosnode kill ydlidar_lidar_publisher',shell=True,stdout=PIPE)
	h=Popen('exec rosnode kill setting_goal',shell=True,stdout=PIPE)
	h=Popen('exec rosnode kill get_vel',shell=True,stdout=PIPE)
	h=Popen('exec rosnode kill emcl_node',shell=True,stdout=PIPE)
	h=Popen('exec rosnode kill laser_scan_matcher_node',shell=True,stdout=PIPE)
	h=Popen('exec rosnode kill map_server',shell=True,stdout=PIPE)
	time.sleep(1)
	

def kill_node(n):
	if n == 0:
		h=Popen('rosnode kill i2c_sender',shell=True,stdout=PIPE)
		time.sleep(1)
def callback(data):
	global mode
    	mode = data.data
	rospy.loginfo("get mode")
	rospy.loginfo(data.data)
def init():
	rospy.init_node('main_node')
	rospy.Subscriber("Run_Mode",Int32,callback, queue_size=5)
	
def loop():
	global mode,array
	time.sleep(0.2)
	if mode == 0:
		rospy.loginfo("mode 0")
		try:
			i2c.write_i2c_block_data(addr, key, row)
		except IOError :
			time.sleep(0.05)
		for i in range(3):
			if array[i] == 1:
				#kill_node(i)
				kill_map()
				kill_map()
				array[i] = 0
	elif mode == 1:
		rospy.loginfo("mode 1")
		if array[0] == 0:
			h=Popen('sh /home/mirs2301/ydlidar_ws/src/myslam/src/rosrun_D4.sh',shell=True)
			# ROURUN cartgrapher rosrun2 map
			array[0] = 1
	elif mode == 2:
		rospy.loginfo("mode 2")
		if array[1] == 0:
			array[1] = 1
	elif mode == 3:
		if array[2] ==0:
			rospy.loginfo("mode 3")
			h=Popen('sh /home/mirs2301/save_map.sh E4',shell=True)
			array[2]=1

if __name__=='__main__':
	init()
	loop()
	esp_reset.esp_reset()
	while not rospy.is_shutdown():
		loop()
	if(rospy.is_shutdown()):
		#kill_map()
		time.sleep(1)
		


