#!/usr/bin/env python

#active 1
#sucseed 3
#pending 0
import rospy
import actionlib
import time
from actionlib_msgs.msg import GoalStatusArray
from geometry_msgs.msg import PoseStamped
st = 1
robot_st = 1
mypos = 0
def setup_node():
	rospy.init_node('setting_goal')
	rospy.Subscriber("/move_base/status",GoalStatusArray,callback, queue_size=20)
def callback(data):
	global st,robot_st,mypos
	if len(data.status_list) > 0:
		rospy.loginfo(data.status_list[0].status)
		st=data.status_list[0].status
	if st == 1:
		robot_st = 1
	if st == 3 or st == 0:
		if robot_st != 1:
			return
		robot_st = 2
		if mypos == 0:
			Goal(0.5,0,1.57*1,1)
			mypos += 1
		if mypos == 1:
			Goal(0.5,0.5,1.57 * 2,1)
			mypos += 1
		elif mypos == 2:
			Goal(0,0.5,1.57 * 3,1)
			mypos += 1
		elif mypos == 3:
			Goal(0,0,0,1)
			mypos =0
	return

def Goal(px, py, pz ,ow):
	pub = rospy.Publisher("/move_base_simple/goal",PoseStamped,queue_size=20)
	rate = rospy.Rate(1)
	rate.sleep()
	now = rospy.Time.now()
	goal_point = PoseStamped()
	goal_point.pose.position.x = px
    	goal_point.pose.position.y = py
	goal_point.pose.orientation.z =  pz
    	goal_point.pose.orientation.w = ow
    	goal_point.header.stamp = now
    	goal_point.header.frame_id = "map"
	pub.publish(goal_point)
	return

if __name__=='__main__':
	setup_node()
	mode = 0
	mypos = 1
	Goal(0.5,0,1.57,1)
	rospy.spin()

		
