#!/usr/bin/env python

#active 1
#sucseed 3
#pending 0
import rospy
import actionlib
import time
from actionlib_msgs.msg import GoalStatusArray
from geometry_msgs.msg import PoseStamped
from std_msgs.msg import Int32
st = 1
robot_st = 1
mypos = 0
count = 0
def setup_node():
	rospy.init_node('setting_goal')
	rospy.Subscriber("/move_base/status",GoalStatusArray,callback, queue_size=20)
def rot_value(num):
	pb = rospy.Publisher("/rot_value",Int32,queue_size=20)
	time.sleep(1)
	n = int(num)
	rospy.loginfo(n)
	pb.publish(n)
	return
def callback(data):
	global st,robot_st,mypos,count
	if len(data.status_list) > 0:
		rospy.loginfo(data.status_list[0].status)
		st=data.status_list[0].status
	if st == 1 :
		robot_st = 1
	if st == 3 or st == 0:
		if robot_st != 1:
			if count > 38:
				robot_st = 1
			count += 1
			return
		robot_st = 2
		count = 0
		if mypos == 0:
			rospy.logwarn(mypos)
			rot_value(7)
			rot_value(0)
			Goal(0.35,0.0,0,1)
			mypos += 1
		elif mypos == 1:
			rospy.logwarn(mypos)
			#rot_value(7)
			#rot_value(0)
			Goal(0.695,0,0,1)
			mypos += 1
		elif mypos == 2:
			rospy.logwarn(mypos)
			rot_value(7)
			rot_value(0)
			Goal(0.695,0.35,1.57,1)
			mypos += 1
		elif mypos == 3:
			rospy.logwarn(mypos)
			#rot_value(7)
			#rot_value(0)
			Goal(0.695,0.7,1.57,1)
			mypos += 1
		elif mypos == 4:
			rospy.logwarn(mypos)
			rot_value(7)
			rot_value(0)
			Goal(0.35,0.7,3.14,1)
			mypos += 1
		elif mypos == 5:
			rospy.logwarn(mypos)
			#rot_value(7)
			#rot_value(0)
			Goal(0,0.70,3.14,1)
			mypos += 1
		elif mypos == 6:
			rospy.logwarn(mypos)
			rot_value(7)
			rot_value(0)
			Goal(0,0.35,-1.57,1)
			time.sleep(1)
			mypos += 1
		elif mypos == 7:
			rospy.logwarn(mypos)
			rot_value(7)
			rot_value(0)
			Goal(0.35,0.35,0,1)
			time.sleep(1)
			mypos += 1
		elif mypos == 8:
			rospy.logwarn(mypos)
			#rot_value(4)
			#rot_value(0)
			Goal(-0.03,0.35,-1.47,1)
			time.sleep(1)
			mypos += 1
		elif mypos == 9:
			rospy.logwarn(mypos)
			#rot_value(18)
			rot_value(1)
			rot_value(0)
			Goal(0,0.01,-1.57,1)
			mypos =0
	return

def Goal(px, py, pz ,ow):
	pub = rospy.Publisher("/move_base_simple/goal",PoseStamped,queue_size=20)
	rate = rospy.Rate(1)
	rate.sleep()
	now = rospy.Time.now()
	goal_point = PoseStamped()
	goal_point.pose.position.x = px
    	goal_point.pose.position.y = py
	goal_point.pose.orientation.z =  pz
    	goal_point.pose.orientation.w = ow
    	goal_point.header.stamp = now
    	goal_point.header.frame_id = "map"
	pub.publish(goal_point)
	return

if __name__=='__main__':
	setup_node()
	mode = 0
	mypos = 1
	Goal(0.35,0.0,0,1)
	rospy.spin()

		
