#!/usr/bin/env python
import rospy
from geometry_msgs.msg import Twist
import time as t
from std_msgs.msg import Float32MultiArray

DATA_NUM = 2
array = [0] * DATA_NUM

def callback(data):
	global array
	#rospy.loginfo("%s",data)
	pub = rospy.Publisher("vel_data_to_cal",Float32MultiArray, queue_size=20)
    	array[1] = float(data.linear.x)
	array[0] = float(data.angular.z)
	forpub = Float32MultiArray(data=array)
	pub.publish(forpub)
def listener():
    global array
    rospy.init_node('vel_receiver')
    rospy.Subscriber("cmd_vel", Twist, callback,queue_size=20)
    
    while not rospy.is_shutdown():
	t.sleep(1)
	rospy.loginfo("\r\nx:%f \r\nz:%f\r\n",array[1],array[0])

if __name__ == '__main__':
    listener()
 

